Attribute VB_Name = "SocketModule"

Public Sockets As New Collection
Public usedcount%

Public Const FD_SETSIZE = 64

Public Const sockClosed = 1
Public Const sockListening = 2
Public Const sockConnecting = 3
Public Const sockConnected = 4

Public Type fd_set
    fd_count As Integer
    fd_array(FD_SETSIZE) As Integer
End Type

Public Type timeval
    tv_sec As Long
    tv_usec As Long
End Type

Public Type Inet_address
    Byte4 As String * 1
    Byte3 As String * 1
    Byte2 As String * 1
    Byte1 As String * 1
End Type

Public Type HostEnt
    h_name As Long
    h_aliases As Long
    h_addrtype As Integer
    h_length As Integer
    h_addr_list As Long
End Type

Public Const hostent_size = 16

Public Type servent
    s_name As Long
    s_aliases As Long
    s_port As Integer
    s_proto As Long
End Type

Public Const servent_size = 14

Public Type protoent
    p_name As Long
    p_aliases As Long
    p_proto As Integer
End Type

Public Const protoent_size = 10

Public Const IPPROTO_TCP = 6
Public Const IPPROTO_UDP = 17

Public Const INADDR_NONE = &HFFFF
Public Const INADDR_ANY = &H0

Public Type sockaddr
    sin_family As Integer
    sin_port As Integer
    sin_addr As Long
    sin_zero As String * 8
End Type

Public Type sockaddrbyte
    sin_family As Integer
    sin_port As Integer
    sin_addr1 As Byte
    sin_addr2 As Byte
    sin_addr3 As Byte
    sin_addr4 As Byte
    sin_zero As String * 8
End Type

Public Const sockaddr_size = 16
Public saZero As sockaddr

Public Const WSA_DESCRIPTIONLEN = 256
Public Const WSA_DescriptionSize = WSA_DESCRIPTIONLEN + 1

Public Const WSA_SYS_STATUS_LEN = 128
Public Const WSA_SysStatusSize = WSA_SYS_STATUS_LEN + 1

Public Type WSADataType
    wVersion As Integer
    wHighVersion As Integer
    szDescription As String * WSA_DescriptionSize
    szSystemStatus As String * WSA_SysStatusSize
    iMaxSockets As Integer
    iMaxUdpDg As Integer
    lpVendorInfo As Long
End Type

Public Const INVALID_SOCKET = -1
Public Const SOCKET_ERROR = -1

Public Const SOCK_STREAM = 1
Public Const SOCK_DGRAM = 2

Public Const MAXGETHOSTSTRUCT = 1024

Public Const AF_INET = 2
Public Const PF_INET = 2

Public Type LingerType
    l_onoff As Integer
    l_linger As Integer
End Type

'---Windows System Functions
    Public Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Public Declare Sub MemCopy Lib "kernel32" Alias "RtlMoveMemory" (Dest As Any, Src As Any, ByVal cb&)
    Public Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As Any) As Long
'---async notification constants
    Public Const SOL_SOCKET = &HFFFF&   ' = 65535
    Public Const SO_LINGER = &H80&  ' = 128
    Public Const FD_READ = &H1& ' = 1
    Public Const FD_WRITE = &H2&    ' = 2
    Public Const FD_ACCEPT = &H8&   ' = 8
    Public Const FD_CONNECT = &H10& ' = 16
    Public Const FD_CLOSE = &H20&   ' = 32
'---SOCKET FUNCTIONS
    Public Declare Function acceptsocket Lib "wsock32.dll" Alias "accept" (ByVal S As Long, addr As sockaddr, addrlen As Long) As Long
    Public Declare Function bind Lib "wsock32.dll" (ByVal S As Long, addr As sockaddr, ByVal namelen As Long) As Long
    Public Declare Function closesocket Lib "wsock32.dll" (ByVal S As Long) As Long
    Public Declare Function connectsocket Lib "wsock32.dll" Alias "connect" (ByVal S As Long, addr As sockaddr, ByVal namelen As Long) As Long
    Public Declare Function ioctlsocket Lib "wsock32.dll" (ByVal S As Long, ByVal cmd As Long, argp As Long) As Long
    Public Declare Function getpeername Lib "wsock32.dll" (ByVal S As Long, sname As Any, namelen As Long) As Long
    Public Declare Function getsockname Lib "wsock32.dll" (ByVal S As Long, sname As sockaddr, namelen As Long) As Long
    Public Declare Function getsockopt Lib "wsock32.dll" (ByVal S As Long, ByVal level As Long, ByVal optname As Long, optval As Any, optlen As Long) As Long
    Public Declare Function setsockopt Lib "wsock32.dll" (ByVal S As Long, ByVal level As Long, ByVal optname As Long, optval As Any, ByVal optlen As Long) As Long
    Public Declare Function htonl Lib "wsock32.dll" (ByVal hostlong As Long) As Long
    Public Declare Function htons Lib "wsock32.dll" (ByVal hostshort As Long) As Integer
    Public Declare Function inet_addr Lib "wsock32.dll" (ByVal cp As String) As Long
    Public Declare Function inet_ntoa Lib "wsock32.dll" (ByVal inn As Long) As Long
    Public Declare Function listensocket Lib "wsock32.dll" Alias "listen" (ByVal S As Long, ByVal backlog As Long) As Long
    Public Declare Function ntohl Lib "wsock32.dll" (ByVal netlong As Long) As Long
    Public Declare Function ntohs Lib "wsock32.dll" (ByVal netshort As Long) As Integer
    Public Declare Function recv Lib "wsock32.dll" (ByVal S As Long, buf As Any, ByVal buflen As Long, ByVal FLAGS As Long) As Long
    Public Declare Function send Lib "wsock32.dll" (ByVal S As Long, buf As Any, ByVal buflen As Long, ByVal FLAGS As Long) As Long
    Public Declare Function Socket Lib "wsock32.dll" Alias "socket" (ByVal af As Long, ByVal s_type As Long, ByVal Protocol As Long) As Long
    '---DATABASE FUNCTIONS
    Public Declare Function gethostbyaddr Lib "wsock32.dll" (addr As Long, ByVal addr_len As Long, ByVal addr_type As Long) As Long
    Public Declare Function gethostbyname Lib "wsock32.dll" (ByVal host_name As String) As Long
    Public Declare Function gethostname Lib "wsock32.dll" (ByVal host_name As String, ByVal namelen As Long) As Long
    Public Declare Function getprotobynumber Lib "wsock32.dll" (ByVal proto As Integer) As Long
    Public Declare Function getprotobyname Lib "wsock32.dll" (ByVal proto_name As String) As Long
    Public Declare Function getservbyport Lib "wsock32.dll" (ByVal Port As Long, ByVal proto As String) As Long
    Public Declare Function getservbyname Lib "wsock32.dll" (ByVal serv_name As String, ByVal proto As String) As Long
    '---WINDOWS EXTENSIONS
    Public Declare Function WSAStartup Lib "wsock32.dll" (ByVal wVR As Long, lpWSAD As WSADataType) As Long
    Public Declare Function WSACleanup Lib "wsock32.dll" () As Long
    Public Declare Sub WSASetLastError Lib "wsock32.dll" (ByVal iError As Long)
    Public Declare Function WSAGetLastError Lib "wsock32.dll" () As Long
    Public Declare Function WSAAsyncSelect Lib "wsock32.dll" (ByVal S As Long, ByVal hwnd As Long, ByVal wMsg As Long, ByVal lEvent As Long) As Long
    Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
    Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal wndrpcPrev As Long, ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Public Const GWL_WNDPROC = (-4)

' ICMP
Public Type IP_OPTION_INFORMATION
    TTL As Byte                   ' Time to Live (used for traceroute)
    Tos As Byte                   ' Type of Service (usually 0)
    FLAGS As Byte                 ' IP header Flags (usually 0)
    OptionsSize As Long           ' Size of Options data (usually 0, max 40)
    OptionsData As String * 128   ' Options data buffer
End Type

Public Type IP_ECHO_REPLY
    Address(0 To 3) As Byte           ' Replying Address
    Status As Long                    ' Reply Status
    RoundTripTime As Long             ' Round Trip Time in milliseconds
    DataSize As Integer               ' reply data size
    Reserved As Integer               ' for system use
    data As Long                      ' pointer to echo data
    Options As IP_OPTION_INFORMATION  ' Reply Options
End Type

Public Declare Function IcmpCreateFile Lib "icmp.dll" () As Long
Public Declare Function IcmpCloseHandle Lib "icmp.dll" (ByVal HANDLE As Long) As Boolean
Public Declare Function IcmpSendEcho Lib "ICMP" (ByVal ICMPHandle As Long, ByVal DestAddress As Long, ByVal RequestData As String, ByVal RequestSize As Integer, RequestOptns As IP_OPTION_INFORMATION, ReplyBuffer As IP_ECHO_REPLY, ByVal ReplySize As Long, ByVal TimeOut As Long) As Boolean

Public Const WS_OVERLAPPED = &H0&
Public Const WS_MINIMIZEBOX = &H20000
Public Const WS_MAXIMIZEBOX = &H10000
Public Const WS_SYSMENU = &H80000
Public Const WS_THICKFRAME = &H40000
Public Const WS_CAPTION = &HC00000                  '  WS_BORDER Or WS_DLGFRAME
Public Const WS_VISIBLE = &H10000000
Public Const WS_OVERLAPPEDWINDOW = (WS_OVERLAPPED Or WS_CAPTION Or WS_SYSMENU Or WS_THICKFRAME Or WS_MINIMIZEBOX Or WS_MAXIMIZEBOX)

Public Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Public Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long

Public Function GetAscIp(ByVal inn As Long) As String
    On Error Resume Next
    Dim lpStr&
    Dim nStr&
    Dim retString$
    retString = String(32, 0)
    lpStr = inet_ntoa(inn)
    If lpStr = 0 Then
        GetAscIp = ""
        Exit Function
    End If
    nStr = lstrlen(lpStr)
    If nStr > 32 Then nStr = 32
    MemCopy ByVal retString, ByVal lpStr, nStr
    retString = Left(retString, nStr)
    GetAscIp = retString
    If Err Then GetAscIp = ""
End Function

Public Function GetHostByNameAlias(ByVal hostname$) As Long
    On Error Resume Next
    'Return IP address as a long, in network byte order

    Dim phe&    ' pointer to host information entry
    Dim heDestHost As HostEnt 'hostent structure
    Dim addrList&
    Dim retIP&
    'first check to see if what we have been passed is a valid IP
    retIP = inet_addr(hostname)
    If retIP = INADDR_NONE Then
        'it wasn't an IP, so do a DNS lookup
        phe = gethostbyname(hostname)
        If phe <> 0 Then
            'Pointer is non-null, so copy in hostent structure
            MemCopy heDestHost, ByVal phe, hostent_size
            'Now get first pointer in address list
            MemCopy addrList, ByVal heDestHost.h_addr_list, 4
            MemCopy retIP, ByVal addrList, heDestHost.h_length
          Else
            'its not a valid address
            retIP = INADDR_NONE
        End If
    End If
    GetHostByNameAlias = Trim$(retIP)
    If Err Then GetHostByNameAlias = INADDR_NONE
End Function

Public Function GetHostByAddress(ByVal addr As Long) As String
    On Error Resume Next
    Dim phe&, ret&
    Dim heDestHost As HostEnt
    Dim hostname$
    phe = gethostbyaddr(addr, 4, PF_INET)
      If phe <> 0 Then
        MemCopy heDestHost, ByVal phe, hostent_size
        hostname = String(256, 0)
        MemCopy ByVal hostname, ByVal heDestHost.h_name, 256
        GetHostByAddress = Left(hostname, InStr(hostname, Chr(0)) - 1)
    Else
        GetHostByAddress = ""
    End If
    If Err Then GetHostByAddress = ""
End Function

Public Function AddrToIP(ByVal AddrOrIP$) As String
    AddrToIP$ = GetAscIp(GetHostByNameAlias(AddrOrIP$))
End Function

Public Function IpToAddr(ByVal AddrOrIP$) As String
    On Error Resume Next
    IpToAddr = GetHostByAddress(GetHostByNameAlias(AddrOrIP$))
    If Err Then IpToAddr = ""
End Function

Public Function DNSLookup(ByVal Address As String) As String
If inet_addr(Address) <> INADDR_NONE Then
DNSLookup = IpToAddr(Address)
ElseIf gethostbyname(Address) <> 0 Then DNSLookup = AddrToIP(Address)
End If
End Function

Public Function GetLocalHostName() As String
    Dim dummy&
    Dim LocalName$
    Dim S$
    On Error Resume Next
    LocalName = String(256, 0)
    LocalName = ""
    dummy = 1
    S = String(256, 0)
    dummy = gethostname(S, 256)
    If dummy = 0 Then
        S = Left(S, InStr(S, Chr(0)) - 1)
        If Len(S) > 0 Then
            LocalName = S
        End If
    End If
    GetLocalHostName = Trim$(LocalName)
    If Err Then GetLocalHostName = ""
End Function

Public Function LongIP(ByVal IPAddress As String) As String
On Error GoTo longipError
Dim nStr&
Dim retString$
Dim lpStr&
    Dim inn&
If InStr(IPAddress, ".") = 0 Then
    If Val(IPAddress) > 2147483647 Then
        inn = Val(IPAddress) - 4294967296#
    Else
        inn = Val(IPAddress)
    End If
    inn = ntohl(inn)
    retString = String(32, 0)
    lpStr = inet_ntoa(inn)
    If lpStr = 0 Then
        LongIP = "0.0.0.0"
        Exit Function
    End If
    nStr = lstrlen(lpStr)
    If nStr > 32 Then nStr = 32
    MemCopy ByVal retString, ByVal lpStr, nStr
    retString = Left(retString, nStr)
    LongIP = retString
    Exit Function
longipError:
    LongIP = ""
    Exit Function
    Resume
Else
inn = inet_addr(IPAddress)
    inn = htonl(inn)
    If inn < 0 Then
        LongIP = CVar(inn + 4294967296#)
    Else
        LongIP = CVar(inn)
    End If
End If
End Function

Public Function WSAGetSelectEvent(ByVal lParam As Long) As Integer
    If (lParam And &HFFFF&) > &H7FFF Then
        WSAGetSelectEvent = (lParam And &HFFFF&) - &H10000
    Else
        WSAGetSelectEvent = lParam And &HFFFF&
    End If
End Function

Public Function WSAGetAsyncError(ByVal lParam As Long) As Integer
    WSAGetAsyncError = (lParam And &HFFFF0000) \ &H10000
End Function

Public Function GetWSAErrorString(ByVal errnum&) As String
Select Case errnum
Case 10004: GetWSAErrorString = "Interrupted system call."
Case 10009: GetWSAErrorString = "Bad file number."
Case 10013: GetWSAErrorString = "Permission Denied."
Case 10014: GetWSAErrorString = "Bad Address."
Case 10022: GetWSAErrorString = "Invalid Argument."
Case 10024: GetWSAErrorString = "Too many open files."
Case 10035: GetWSAErrorString = "Operation would block."
Case 10036: GetWSAErrorString = "Operation now in progress."
Case 10037: GetWSAErrorString = "Operation already in progress."
Case 10038: GetWSAErrorString = "Socket operation on nonsocket."
Case 10039: GetWSAErrorString = "Destination address required."
Case 10040: GetWSAErrorString = "Message too long."
Case 10041: GetWSAErrorString = "Protocol wrong type for socket."
Case 10042: GetWSAErrorString = "Protocol not available."
Case 10043: GetWSAErrorString = "Protocol not supported."
Case 10044: GetWSAErrorString = "Socket type not supported."
Case 10045: GetWSAErrorString = "Operation not supported on socket."
Case 10046: GetWSAErrorString = "Protocol family not supported."
Case 10047: GetWSAErrorString = "Address family not supported by protocol family."
Case 10048: GetWSAErrorString = "Address already in use."
Case 10049: GetWSAErrorString = "Can't assign requested address."
Case 10050: GetWSAErrorString = "Network is down."
Case 10051: GetWSAErrorString = "Network is unreachable."
Case 10052: GetWSAErrorString = "Network dropped connection."
Case 10053: GetWSAErrorString = "Software caused connection abort."
Case 10054: GetWSAErrorString = "Connection reset by peer."
Case 10055: GetWSAErrorString = "No buffer space available."
Case 10056: GetWSAErrorString = "Socket is already connected."
Case 10057: GetWSAErrorString = "Socket is not connected."
Case 10058: GetWSAErrorString = "Can't send after socket shutdown."
Case 10059: GetWSAErrorString = "Too many references: can't splice."
Case 10060: GetWSAErrorString = "Connection timed out."
Case 10061: GetWSAErrorString = "Connection refused."
Case 10062: GetWSAErrorString = "Too many levels of symbolic links."
Case 10063: GetWSAErrorString = "File name too long."
Case 10064: GetWSAErrorString = "Host is down."
Case 10065: GetWSAErrorString = "No route to host."
Case 10066: GetWSAErrorString = "Directory not empty."
Case 10067: GetWSAErrorString = "Too many processes."
Case 10068: GetWSAErrorString = "Too many users."
Case 10069: GetWSAErrorString = "Disk quota exceeded."
Case 10070: GetWSAErrorString = "Stale NFS file handle."
Case 10071: GetWSAErrorString = "Too many levels of remote in path."
Case 10091: GetWSAErrorString = "Network subsystem is unusable."
Case 10092: GetWSAErrorString = "Winsock DLL cannot support this application."
Case 10093: GetWSAErrorString = "Winsock not initialized."
Case 10101: GetWSAErrorString = "Disconnect."
Case 11001: GetWSAErrorString = "Host not found."
Case 11002: GetWSAErrorString = "Nonauthoritative host not found."
Case 11003: GetWSAErrorString = "Nonrecoverable error."
Case 11004: GetWSAErrorString = "Valid name, no data record of requested type."
Case Else:
End Select
End Function

Public Function SetSockLinger(ByVal SockNum&, ByVal onoff%, ByVal LingerTime%) As Long
Dim Linger As LingerType
Linger.l_onoff = onoff
Linger.l_linger = LingerTime
If setsockopt(SockNum, SOL_SOCKET, SO_LINGER, Linger, 4) Then
   'Debug.Print "Error setting linger info: " & WSAGetLastError()
   SetSockLinger = SOCKET_ERROR
Else
   If getsockopt(SockNum, SOL_SOCKET, SO_LINGER, Linger, 4) Then
      'Debug.Print "Error getting linger info: " & WSAGetLastError()
      SetSockLinger = SOCKET_ERROR
   Else
      'Debug.Print "Linger is on if nonzero: "; Linger.l_onoff
      'Debug.Print "Linger time if linger is on: "; Linger.l_linger
   End If
End If
End Function

Public Function GetPeerHostByAddr(Socket As Long) As String
Dim Sock As sockaddrbyte
Call getpeername(Socket, Sock, sockaddr_size)
GetPeerHostByAddr = Sock.sin_addr1 & "." & Sock.sin_addr2 & "." & Sock.sin_addr3 & "." & Sock.sin_addr4
End Function

Public Function GetPeerHostByName(Socket As Long) As String
Dim Sock As sockaddr
Call getpeername(Socket, Sock, sockaddr_size)
GetPeerHostByName = GetHostByAddress(Sock.sin_addr)
End Function

Public Function GetPeerPort(Socket As Long) As Long
Dim Sock As sockaddr
Call getpeername(Socket, Sock, sockaddr_size)
p% = ntohs(Sock.sin_port)
If p% < 0 Then GetPeerPort = p% + 65536 Else GetPeerPort = p%
End Function

Public Function GetProtocol(Protocol)
Dim peDestProt As protoent
Dim ppe As Long
If TypeName(Protocol) = "String" Then
ppe = getprotobyname(Protocol)
If ppe = 0 Then
GetProtocol = -1
Exit Function
End If
MemCopy peDestProt, ByVal ppe, protoent_size
GetProtocol = peDestProt.p_proto
End If
If IsNumeric(Protocol) Then
ppe = getprotobynumber(CInt(Protocol))
If ppe = 0 Then
GetProtocol = -1
Exit Function
End If
MemCopy peDestProt, ByVal ppe, protoent_size
Dim strProto As String
strProto = String$(256, 0)
MemCopy ByVal strProto, ByVal peDestProt.p_name, 256
strProto = Left$(strProto, InStr(strProto, Chr$(0)) - 1)
GetProtocol = strProto
End If
End Function

Public Function GetService(Service, Protocol)
Dim seDestServ As servent
Dim pse As Long
If IsNumeric(Protocol) Then Protocol = GetProtocol(CInt(Protocol))
If TypeName(Service) = "String" Then
pse = getservbyname(Service, Protocol)
If pse = 0 Then
GetService = -1
Exit Function
End If
MemCopy seDestServ, ByVal pse, servent_size
GetService = ntohs(seDestServ.s_port)
End If
If IsNumeric(Service) Then
pse = getservbyport(htons(CLng(Service)), Protocol)
If pse = 0 Then
GetService = -1
Exit Function
End If
MemCopy seDestServ, ByVal pse, servent_size
Dim strService As String
strService = String$(256, 0)
MemCopy ByVal strService, ByVal seDestServ.s_name, 256
strService = Left$(strService, InStr(strService, Chr$(0)) - 1)
GetService = strService
End If
End Function

Public Function GetLocalHost(Socket As Long) As String
Dim Sock As sockaddr
Call getsockname(Socket, Sock, sockaddr_size)
GetLocalHost = GetHostByAddress(Sock.sin_addr)
End Function

Public Function GetLocalPort(Socket As Long) As Integer
Dim Sock As sockaddr
Call getsockname(Socket, Sock, sockaddr_size)
GetLocalPort = ntohs(Sock.sin_port)
End Function

Public Function PingHost(Host As String)
Dim ICMPHandle As Long

' Get IP Address
If inet_addr(Host) = INADDR_NONE Then
Host = DNSLookup(Host)
If Host = "" Then Exit Function
End If
ICMPHandle = IcmpCreateFile()
If ICMPHandle = 0 Then Exit Function ' Error
Dim IPOption As IP_OPTION_INFORMATION
IPOption.TTL = "255"
Dim buf As String
buf = String$(32, 0) ' Intialize Buffer
Dim IPReply As IP_ECHO_REPLY
If IcmpSendEcho(ICMPHandle, GetHostByNameAlias(Host), buf, 32, IPOption, IPReply, Len(IPReply) + 8, 2700) = False Then PingHost = "Request Timed Out"
If PingHost = "" Then PingHost = GetICMPError$(CInt(IPReply.Status))
If PingHost = "" Then PingHost = IPReply.RoundTripTime
Call IcmpCloseHandle(ICMPHandle)
End Function

Public Function TraceRt(Host As String)
Dim ICMPHandle As Long

' Get IP Address
If inet_addr(Host) = INADDR_NONE Then
Host = DNSLookup(Host)
If Host = "" Then Exit Function
End If
ICMPHandle = IcmpCreateFile()
If ICMPHandle = 0 Then Exit Function ' Error
Dim IPOption As IP_OPTION_INFORMATION
Dim buf As String
Dim IPReply As IP_ECHO_REPLY
Dim HopAddress As String
Dim HopCounter As Integer
For IPOption.TTL = 2 To 30
buf = String$(32, 0)
If IcmpSendEcho(ICMPHandle, GetHostByNameAlias(Host), buf, 32, IPOption, IPReply, Len(IPReply) + 8, 2700) = False Then
GoTo EndEcho
End If
If HopCounter = 0 Then TraceRt = "Hop #0" Else TraceRt = TraceRt & vbCrLf & "Hop #" & HopCounter
HopAddress = CStr(IPReply.Address(0)) & "." & CStr(IPReply.Address(1)) & "." & CStr(IPReply.Address(2)) & "." & CStr(IPReply.Address(3))
TraceRt = TraceRt & "  " & HopAddress
If HopAddress = Host Then Exit For
HopCounter = HopCounter + 1
EndEcho:
If IPOption.TTL = 30 Then TraceRt = TraceRt & vbCrLf & "Trace Route to Long."
DoEvents
Next IPOption.TTL
End Function

Public Function GetICMPError(Error As Integer) As String
Select Case Error
Case 11001: GetICMPError = "Buffer too Small"
Case 11002: GetICMPError = "Destination Network Not Reachable"
Case 11003: GetICMPError = "Destination Host Not Reachable"
Case 11004: GetICMPError = "Destination Protocol Not Reachable"
Case 11005: GetICMPError = "Destination Port Not Reachable"
Case 11006: GetICMPError = "No Resources Available"
Case 11007: GetICMPError = "Bad Option"
Case 11008: GetICMPError = "Hardware Error"
Case 11009: GetICMPError = "Packet too Big"
Case 11010: GetICMPError = "Request Timed Out"
Case 11011: GetICMPError = "Bad Request"
Case 11012: GetICMPError = "Bad Route"
Case 11013: GetICMPError = "TTL Expired in Transit"
Case 11014: GetICMPError = "TTL Expired Reassembly"
Case 11015: GetICMPError = "Parameter Problem"
Case 11016: GetICMPError = "Source Quench"
Case 11017: GetICMPError = "Option too Big"
Case 11018: GetICMPError = "Bad Destination"
Case 11019: GetICMPError = "Address Deleted"
Case 11020: GetICMPError = "Spec MTU Change"
Case 11021: GetICMPError = "MTU Change"
Case 11022: GetICMPError = "Unload"
Case 11050: GetICMPError = "General Failure"
End Select
End Function

Public Function SetWindowProc(hwnd&, func&) As Long

If func& Then
   SetWindowProc = SetWindowLong(hwnd&, GWL_WNDPROC, func&)
Else
   SetWindowProc = SetWindowLong(hwnd&, GWL_WNDPROC, AddressOf WindowProc)
End If

End Function

Public Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Dim S As CSocket
Set S = Nothing
For n% = 1 To Sockets.Count
   If Sockets(n%).SocketHandle = wParam Then Set S = Sockets(n%)
Next
If S Is Nothing Then Exit Function

If uMsg <> 2000 Then
   If S.WindowProcOld Then WindowProc = CallWindowProc(S.WindowProcOld, hwnd, uMsg, wParam, ByVal lParam)
   Exit Function
End If

Dim WSAEvent As Long, WSAError As Long
WSAEvent = WSAGetSelectEvent(lParam)
WSAError = WSAGetAsyncError(lParam)

'Debug.Print , , , "wp: "; WSAEvent, WSAError

Select Case WSAEvent ' Determine Event
Case FD_CLOSE ' Socket Close
   S.WindowProc WSAEvent, 0
Case FD_CONNECT
   If WSAError = 0 Then ' No Error, Connected
      S.WindowProc WSAEvent, 0
   Else ' Error, Not Connected
      er$ = GetWSAErrorString$(WSAError&)
      closesocket wParam
      S.WindowProc 0, er$
   End If
Case FD_ACCEPT
   S.WindowProc WSAEvent, 0
Case FD_READ
' So sollte es idealerweise und lt. Doku funktionieren:

'   ReDim buf(0 To 1023) As Byte
'   Dim buflen As Long
'   buflen = recv(wParam, buf(0), 1024, 0)
'   If buflen = 1024 Then
'      S.WindowProc WSAEvent, buf
'   ElseIf buflen > 0 Then
'      ReDim Preserve buf(0 To buflen - 1)
'      S.WindowProc WSAEvent, buf
'   End If
   
' Unter NT4 macht die obige Lsung aber Probleme beim Zugriff auf
' IIS-Server. Mit einer Schleife wie der folgenden gehts aber:
    Dim buflen As Long
    Do While True
       ReDim buf(0 To 1024 - 1) As Byte
       buflen = recv(wParam, buf(0), 1024, 0)
       If buflen <= 0 Then Exit Do
       If buflen < 1024 Then ReDim Preserve buf(0 To buflen - 1)
       S.WindowProc WSAEvent, buf
    Loop
   
Case FD_WRITE
   S.WindowProc WSAEvent, 0
End Select

End Function

